<?php
namespace Contabilidade\Repositories;

use \Contabilidade\Entities\Capalote as Lote;
use Geral\Util\Ambiente;
use \Setforms2\Shared\Connection;

class Capalote extends \Doctrine\ORM\EntityRepository
{

    /**
     * DCU002 - Gerar Lote Contábil
     * Insere um registro na tabela Capalote
     *
     * @param Lote $lote
     * @return boolean
     * @throws \Exception
     */
    public static function insertCapalote( Lote $lote)
    {
        try {
            $params = array(
                'P_CDEMPRESA' => $lote->getCdempresa()?$lote->getCdempresa():"",
                'P_CDLOTE' => $lote->getCdlote()?$lote->getCdlote():"",
                'P_DTINICLOTE' => $lote->getDtiniclote()?$lote->getDtiniclote():"",
                'P_DTFINALOTE' => $lote->getDtfinalote()?$lote->getDtfinalote():"",
                'P_IDLOTE' => $lote->getIdlote()?$lote->getIdlote():"",
                'P_DSOBSELOTE' => $lote->getDsobselote()?$lote->getDsobselote():"",
                'P_IDRECONTCAPLOTE' => $lote->getIdrecontcaplote()?$lote->getIdrecontcaplote():"",
                'P_NRORG' => Ambiente::getNrorgTrabalho() ? Ambiente::getNrorgTrabalho():""
            );
            $sql = <<<SQL
INSERT INTO CAPALOTE (
	CDEMPRESA,
	CDLOTE,
	DTINICLOTE,
	DTFINALOTE,
	IDLOTE,
	DSOBSELOTE,
	IDRECONTCAPLOTE,
	NRORG
)VALUES(
	:P_CDEMPRESA,
	:P_CDLOTE,
	:P_DTINICLOTE,
	:P_DTFINALOTE,
	:P_IDLOTE,
	:P_DSOBSELOTE,
	:P_IDRECONTCAPLOTE,
	:P_NRORG
)
SQL;
            $resultado = Connection::getInstance()->execute($sql, $params);
            if ($resultado) {
                return true;
            } else {
                return false;
            }
        } catch (\Exception $e) {
            throw $e;
        }

    }

}