<?php
namespace Geral\Logic;

/**
 * Created by JetBrains PhpStorm.
 * User: paulopereira
 * Date: 28/11/12
 * Time: 16:23
 * To change this template use File | Settings | File Templates.
 */
abstract class Exception extends \Exception
{

    private $params = array();

    /**
     * Insere um array com os parametros da excecao.
     *
     * @param array|null $params
     */
    public function setParams(array $params = null)
    {
        $this->params = $params;
    }

    /**
     * Retorna o array de parametros da excecao.
     *
     * @return array
     */
    public function getParams()
    {
        return $this->params;
    }

    /**
     * Insere mais um parametro no array de parametros da excecao.
     *
     * @param $param
     */
    public function addParam($param)
    {
        array_push($this->params, $param);
    }

    /**
     * Retorna o primeiro elemento da lista de parametros da excessao.
     *
     * @return mixed
     */
    public function getParam()
    {
        \Geral\Util\AcumuladorDeMensagens::getInstance()->setMensagem("texto", "parametros", \Geral\Util\Mensagem::VALIDACAO);

        return array_shift($this->params);
    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @abstract
     * @return string
     */
    public abstract function getMessageName();

}
